using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace CellViewLib
{
	/// <summary>
	/// 򵥵ؼ
	///  Ԭ 2007-12-26
	/// </summary>
	public class CellView : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CellView()
		{
			this.AutoScroll = true ;
			// õ Windows.Forms ġ
			InitializeComponent();

			// TODO:  InitializeComponent úκγʼ

		}

		/// <summary> 
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region ɵĴ
		/// <summary> 
		/// ֧ķ - Ҫʹô༭ 
		/// ޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// CellView
			// 
			this.Name = "CellView";
			this.Size = new System.Drawing.Size(392, 320);

		}
		#endregion

		private int intRowHeight = 40 ;
		/// <summary>
		/// и߶
		/// </summary>
		public int RowHeight
		{
			get{ return intRowHeight ;}
			set{ intRowHeight = value;}
		}

		private Color intGridColor = Color.Black ;
		/// <summary>
		/// ɫ
		/// </summary>
		public Color GridColor
		{
			get{ return intGridColor ;}
			set{ intGridColor = value;}
		}

		private Color intGridBackColor = Color.LightGray ;
		/// <summary>
		/// 񱳾ɫ
		/// </summary>
		public Color GridBackColor
		{
			get{ return intGridBackColor ;}
			set{ intGridBackColor = value;}
		}

		private CellDocument myDocument = new CellDocument();
		/// <summary>
		/// ĵ
		/// </summary>
		[System.ComponentModel.Browsable( false )]
		public CellDocument Document
		{
			get{ return myDocument ;}
		}

		/// <summary>
		/// ƿؼ
		/// </summary>
		/// <param name="e">ͼβ</param>
		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint (e);
			System.Drawing.Rectangle ClipRect = e.ClipRectangle ;
			ClipRect.Offset( - this.AutoScrollPosition.X , - this.AutoScrollPosition.Y );
			// ת
			e.Graphics.TranslateTransform( this.AutoScrollPosition.X , this.AutoScrollPosition.Y );
			// Ļʶ
			Pen GridPen = null;
			if( intGridColor.A != 0 )
			{
				GridPen = new Pen( intGridColor );
			}
			// Ļˢ
			SolidBrush GridBrush = null;
			if( intGridBackColor.A != 0 )
			{
				GridBrush = new SolidBrush( intGridBackColor );
			}
			// ıĻˢ
			SolidBrush TextBrush = new SolidBrush( this.ForeColor );
			// ıʹõĸʽ
			StringFormat TextFormat = new StringFormat();
			TextFormat.Alignment = System.Drawing.StringAlignment.Near ;
			TextFormat.LineAlignment = System.Drawing.StringAlignment.Center ;
			TextFormat.FormatFlags = System.Drawing.StringFormatFlags.NoWrap ;

			try
			{
				foreach( CellRow row in myDocument )
				{
					foreach( Cell cell in row )
					{
						// беĵԪ,ԵԪ
						Rectangle bounds = cell.Bounds ;
						// Ԫͼоβཻ,Ԫ,תһԪ.
						if( ClipRect.IntersectsWith( bounds ) == false )
						{
							continue ;
						}
						if( cell.Selected )
						{
							// Ԫѡ״̬ʾȱɫ
							e.Graphics.FillRectangle( SystemBrushes.Highlight , bounds );
						}
						else
						{
							// ƵԪ񱳾
							if( GridBrush != null )
							{
								e.Graphics.FillRectangle( GridBrush , bounds );
							}
						}
						if( GridPen != null )
						{
							// ƵԪ߿
							e.Graphics.DrawRectangle( GridPen , bounds );
						}
						if( cell.Text != null )
						{
							// ƵԪı
							e.Graphics.DrawString( 
								cell.Text ,
								this.Font ,
								cell.Selected ? SystemBrushes.HighlightText : TextBrush ,
								new RectangleF( 
								cell.Left , 
								cell.Top , 
								cell.Width , 
								cell.Height ) ,
								TextFormat );
						}
					}
				}
			}
			finally
			{
				if( GridPen != null )
					GridPen.Dispose();
				if( GridBrush != null )
					GridBrush.Dispose();
				TextBrush.Dispose();
				TextFormat.Dispose();
			}
		}

		/// <summary>
		/// 㵥ԪС,Ű
		/// </summary>
		/// <param name="g">ıСʹõͼλƶ</param>
		public void RefreshSize( System.Drawing.Graphics g )
		{
			ArrayList cells = new ArrayList();
			System.Drawing.Size ViewSize = Size.Empty ;
			int LeftCount = 0 ;
			for( int iCount = 0 ; iCount < 1000 ; iCount ++ )
			{
				// еı,ָеĵԪ
				// ˴ı1000
				cells.Clear();
				for( int RowIndex = 0 ; RowIndex < myDocument.Count ; RowIndex ++ )
				{
					CellRow row = myDocument[ RowIndex ] ;
					if( iCount < row.Count )
					{
						Cell cell = row[ iCount ] ;
						// õԪλ
						cell.intLeft = LeftCount ;
						cell.intTop = RowIndex * this.RowHeight ;
						cells.Add( cell );
					}
				}
				if( cells.Count == 0 )
					break;
				// 㵱ǰеĵԪ
				int MaxWidth = 40 ;
				foreach( Cell cell in cells )
				{
					string txt = cell.Text ;
					if( txt != null && txt.Length > 0 )
					{
						System.Drawing.SizeF size = g.MeasureString( 
							txt , 
							this.Font ,
							1000 ,
							System.Drawing.StringFormat.GenericDefault  );
						if( MaxWidth < ( int ) size.Width )
							MaxWidth = ( int ) size.Width ;
					}
				}
				MaxWidth += 10 ;
				// õԪĴС
				foreach( Cell cell in cells )
				{
					cell.intWidth = MaxWidth ;
					cell.intHeight = this.RowHeight ;
					if( cell.Left + cell.Width > ViewSize.Width )
						ViewSize.Width = cell.Left + cell.Width ;
					if( cell.Top + cell.Height > ViewSize.Height )
						ViewSize.Height = cell.Top + cell.Height ;
				}
				LeftCount += MaxWidth ;
			}
			ViewSize.Width += 10 ;
			ViewSize.Height += 10 ;
			if( this.AutoScrollMinSize.Equals( ViewSize ) == false )
			{
				this.AutoScrollMinSize = ViewSize ;
				this.Invalidate();
			}
		}//public void RefreshSize( System.Drawing.Graphics g )

		/// <summary>
		/// ĳԪʾЧ,Ҫ»
		/// </summary>
		/// <param name="cell">Ԫ</param>
		public void InvalidateCell( Cell cell )
		{
			Rectangle rect = new Rectangle( cell.Left , cell.Top , cell.Width , cell.Height );
			rect.Offset(  this.AutoScrollPosition.X , this.AutoScrollPosition.Y );
			this.Invalidate( rect );
		}
		/// <summary>
		/// һ갴ʱλ
		/// </summary>
		private Point LastMousePosition = new Point( -1 , -1);

		/// <summary>
		/// 갴¼
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseDown(MouseEventArgs e)
		{
			base.OnMouseDown (e);
			// λת
			Point p = new Point( e.X , e.Y );
			p.Offset( - this.AutoScrollPosition.X , - this.AutoScrollPosition.Y );
			LastMousePosition = p ;
			Cell[] cells = myDocument.Cells ;
			foreach( Cell cell in cells )
			{
				Rectangle bounds = cell.Bounds ;
				bool select = bounds.Contains( p );
				if( cell.Selected != select )
				{
					InvalidateCell( cell );
					cell.Selected = select ;
				}
			}
		}
		/// <summary>
		/// ƶ¼
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseMove(MouseEventArgs e)
		{
			base.OnMouseMove (e);
			if( LastMousePosition.X >= 0 )
			{
				// λת
				Point p = new Point( e.X , e.Y );
				p.Offset( - this.AutoScrollPosition.X , - this.AutoScrollPosition.Y );
				//  p   LastMousePosition һѡ
				Rectangle SelectRect = Rectangle.Empty ;
				if( p.X > LastMousePosition.X )
				{
					SelectRect.X = LastMousePosition.X ;
					SelectRect.Width = p.X - LastMousePosition.X ;
				}
				else
				{
					SelectRect.X = p.X ;
					SelectRect.Width = LastMousePosition.X - p.X ;
				}
				if( p.Y > LastMousePosition.Y )
				{
					SelectRect.Y = LastMousePosition.Y ;
					SelectRect.Height = p.Y - LastMousePosition.Y ;
				}
				else
				{
					SelectRect.Y = p.Y ;
					SelectRect.Height = LastMousePosition.Y - p.Y ;
				}
				foreach( Cell cell in myDocument.Cells )
				{
					bool flag = SelectRect.IntersectsWith( cell.Bounds );
					if( cell.Selected != flag )
					{
						cell.Selected = flag ;
						this.InvalidateCell( cell );
					}
				}
			}
		}
		/// <summary>
		/// 갴ɿ¼
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseUp(MouseEventArgs e)
		{
			base.OnMouseUp (e);
			LastMousePosition = new Point( -1 , -1 );
		}

		/// <summary>
		/// ѡĵԪı
		/// </summary>
		public void Copy()
		{
			System.Text.StringBuilder myStr = new System.Text.StringBuilder();
			foreach( CellRow row in myDocument )
			{
				bool find = false;
				foreach( Cell cell in row )
				{
					if( cell.Selected )
					{
						myStr.Append( cell.Text );
						myStr.Append( " " );
						find = true ;
					}
				}
				if( find )
					myStr.Append( System.Environment.NewLine );
			}
			if( myStr.Length > 0 )
			{
				System.Windows.Forms.DataObject data = new DataObject();
				data.SetData( myStr.ToString());
				System.Windows.Forms.Clipboard.SetDataObject( data , true );
			}
		}

		/// <summary>
		/// һDataTable 
		/// </summary>
		/// <param name="table">ݱ</param>
		public void FillDataTable( DataTable table )
		{
			if( table == null )
				throw new ArgumentNullException("table");
			myDocument.Clear();
			CellRow row = new CellRow();
			myDocument.Add( row );
			foreach( DataColumn col in table.Columns )
			{
				row.Add( col.ColumnName );
			}
			foreach( DataRow drow in table.Rows )
			{
				row = new CellRow();
				foreach( DataColumn col in table.Columns )
				{
					object v = drow[ col ] ;
					string txt = "";
					if( v == null || DBNull.Value.Equals( v ))
						txt = "[NULL]";
					else
						txt = Convert.ToString( v );
					row.Add( txt );
				}
				myDocument.Add( row );
			}
			using( System.Drawing.Graphics g = this.CreateGraphics())
			{
				this.RefreshSize( g );
				this.Invalidate();
			}
		}

	}//public class CellView : System.Windows.Forms.UserControl
}