using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace PenMarkLib
{
	/// <summary>
	/// ǩͼؼ
	/// </summary>
	public class PenMarkControl : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PenMarkControl()
		{
			this.AutoScroll = true ;
			// õ Windows.Forms ġ
			InitializeComponent();

			// TODO:  InitializeComponent úκγʼ

		}

		/// <summary> 
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region ɵĴ
		/// <summary> 
		/// ֧ķ - Ҫʹô༭ 
		/// ޸Ĵ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// PenMarkControl
			// 
			this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.Name = "PenMarkControl";
			this.Size = new System.Drawing.Size(576, 448);

		}
		#endregion

		/// <summary>
		/// ǩϢĵ
		/// </summary>
		private PenMarkInfoDocument myDocument = new PenMarkInfoDocument();
		/// <summary>
		/// ǩϢĵ
		/// </summary>
		public PenMarkInfoDocument Document
		{
			get{ return myDocument ;}
		}

		/// <summary>
		/// ǰǩ
		/// </summary>
		private PenMarkInfo myCurrentInfo = null;
		/// <summary>
		/// ǰǩ
		/// </summary>
		public PenMarkInfo CurrentInfo
		{
			get{ return myCurrentInfo ;}
		}

		/// <summary>
		/// ʼǩ
		/// </summary>
		/// <param name="UserName">ǩ</param>
		/// <param name="LineWidth">ǩ</param>
		public void BeginMark( string UserName , int LineWidth )
		{
			if( myCurrentInfo != null )
			{
				System.Drawing.Rectangle rect = myCurrentInfo.Bounds ;
				rect.Offset( this.AutoScrollPosition.X , this.AutoScrollPosition.Y );
				this.Invalidate( rect );
			}
			myCurrentInfo = new PenMarkInfo();
			myCurrentInfo.Creator = UserName ;
			myCurrentInfo.CreationTime = DateTime.Now ;
			myCurrentInfo.LineWidth = LineWidth ;
		}
		/// <summary>
		/// ǩ
		/// </summary>
		public void EndMark()
		{
			if( this.Marking )
			{
				if( myCurrentInfo.Lines.Count > 0 )
				{
					myDocument.Add( myCurrentInfo );
				}
				else
				{
					myCurrentInfo = null;
				}
			}
		}
		/// <summary>
		/// ǩϢָļ
		/// </summary>
		/// <param name="strFileName">ָļ</param>
		public void SaveMarks( string strFileName )
		{
			myDocument.Save( strFileName );
		}
		/// <summary>
		/// ָļмǩϢ
		/// </summary>
		/// <param name="strFileName">ָļ</param>
		public void LoadMarks( string strFileName )
		{
			myDocument = PenMarkInfoDocument.Load( strFileName );
			this.Invalidate();
		}
		
		/// <summary>
		/// ǩ
		/// </summary>
		/// <remarks>ǰǩڶһĵؼǩ״̬</remarks>
		public bool Marking
		{
			get{ return myCurrentInfo != null && myDocument.Contains( myCurrentInfo ) == false ;}
		}
 
		/// <summary>
		/// ǰ㼯
		/// </summary>
		private PointArrayList myCurrentLine = null;
		/// <summary>
		/// һε
		/// </summary>
		private System.Drawing.Point LastPoint = System.Drawing.Point.Empty ;
		 
		/// <summary>
		/// 갴¼
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMouseDown(MouseEventArgs e)
		{
			base.OnMouseDown (e);
			if( this.Marking )
			{
				// ǩ
				myCurrentLine = new PointArrayList();
				LastPoint = new Point( e.X , e.Y );
			}
			else
			{
				// жǷĳǩ
				int x = e.X - this.AutoScrollPosition.X ;
				int y = e.Y - this.AutoScrollPosition.Y ;
				foreach( PenMarkInfo info in myDocument )
				{
					// жǷĳǩĳ
					foreach( PointArrayList line in info.Lines )
					{
						foreach( Point p in line )
						{
							double r = ( p.X - x ) * ( p.X - x ) + ( p.Y - y ) * ( p.Y - y );
							if( r < 13 )
							{
								System.Drawing.Rectangle rect = info.Bounds ;
								if( myCurrentInfo != null )
								{
									rect = System.Drawing.Rectangle.Union( rect , myCurrentInfo.Bounds );
									rect.Offset( this.AutoScrollPosition.X , this.AutoScrollPosition.Y );
								}
								myCurrentInfo = info ;
								this.Invalidate( rect );
								goto EndElse ;
							}
						}
					}
				}
			EndElse: ;
			}
		}

		/// <summary>
		/// ƶ¼
		/// </summary>
		/// <param name="e">¼</param>
		protected override void OnMouseMove(MouseEventArgs e)
		{
			base.OnMouseMove (e);
			if( this.Marking && myCurrentLine != null )
			{
				using( System.Drawing.Graphics g = this.CreateGraphics())
				{
					using( System.Drawing.Pen p = new Pen( myCurrentInfo.Color , myCurrentInfo.LineWidth ))
					{
						g.DrawLine( p , LastPoint , new Point( e.X , e.Y ));
					}
				}
				LastPoint = new Point( e.X , e.Y );
				Point point = new Point( e.X - this.AutoScrollPosition.X , e.Y - this.AutoScrollPosition.Y );
				myCurrentLine.Add( point );
			}
		}
		/// <summary>
		/// 갴ɿ¼
		/// </summary>
		/// <param name="e">¼</param>
		protected override void OnMouseUp(MouseEventArgs e)
		{
			base.OnMouseUp (e);
			if( this.Marking )
			{
				if( myCurrentLine != null )
				{
					System.Drawing.Rectangle rect = myCurrentLine.Bounds ;
					if( rect.Width > 5 || rect.Height >= 5 )
					{
						myCurrentInfo.Lines.Add( myCurrentLine);
					}
					myCurrentLine = null;
				}
			}
		}
		/// <summary>
		/// û
		/// </summary>
		/// <param name="e"></param>
		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint (e);
			e.Graphics.TranslateTransform( this.AutoScrollPosition.X , this.AutoScrollPosition.Y );
			System.Drawing.Rectangle ClipRect = e.ClipRectangle ;
			ClipRect.Offset( - this.AutoScrollPosition.X , - this.AutoScrollPosition.Y );
			System.Collections.ArrayList list = new ArrayList();
			list.AddRange( this.myDocument );
			if( this.Marking )
			{
				list.Add( this.myCurrentInfo );
			}
			foreach( PenMarkInfo info in list )
			{
				info.Draw( e.Graphics , ClipRect );
			}
			if( myCurrentInfo != null )
			{
				System.Drawing.Rectangle rect = myCurrentInfo.Bounds ;
				System.Windows.Forms.ControlPaint.DrawFocusRectangle( e.Graphics , rect );
				//System.Windows.Forms.ControlPaint.DrawGrabHandle( e.Graphics , rect , true , false );
			}
		}
	}//public class PenMarkControl : System.Windows.Forms.UserControl
}