using System;
using System.Drawing ;
using System.Collections ;
namespace PenMarkLib
{
	/// <summary>
	/// б
	/// </summary>
	/// <remarks>
	/// ʵһǿ͵ĵб,ܱϢ
	///  Ԭ 2007-12-19
	/// </remarks>
	public class PointArrayList : System.Collections.ICollection
	{
		/// <summary>
		/// ʼ
		/// </summary>
		public PointArrayList()
		{
		}

		/// <summary>
		/// ʼ
		/// </summary>
		/// <param name="ps">ʼ߱ĵ</param>
		public PointArrayList( Point[] ps )
		{
			if( ps != null )
			{
				values = ps ;
				intCount = ps.Length ;
			}
		}

		/// <summary>
		/// ео
		/// </summary>
		public System.Drawing.Rectangle Bounds
		{
			get
			{
				if( intCount == 0 )
					return System.Drawing.Rectangle.Empty ;
				System.Drawing.Rectangle rect = new Rectangle(
					values[ 0 ].X ,
					values[ 0 ].Y ,
					0 , 
					0 );
				for( int iCount = 1 ; iCount < intCount ; iCount ++ )
				{
					Point p = values[ iCount ] ;
					if( p.X < rect.Left )
					{
						rect.Width = rect.Right - p.X ;
						rect.X = p.X ;
					}
					else if( p.X > rect.Right )
					{
						rect.Width = p.X - rect.Left ;
					}
					if( p.Y < rect.Top )
					{
						rect.Height = rect.Bottom - p.Y ;
						rect.Y = p.Y ;
					}
					else if( p.Y > rect.Bottom )
					{
						rect.Height = p.Y - rect.Top ;
					}
				}
				return rect ;
			}
		}

		/// <summary>
		/// ָųĵ
		/// </summary>
		public Point this[ int index ]
		{
			get{ return values[ index ] ;}
			set
			{
				values[ index ] = value;
				intVersion ++ ;
			}
		}

		/// <summary>
		/// боָݵĵ
		/// </summary>
		/// <param name="x">ָX</param>
		/// <param name="y">ָY</param>
		/// <returns>ҵĵбеĴ0ʼδҵ򷵻-1</returns>
		public int IndexOf( int x , int y )
		{
			for( int iCount = 0 ; iCount < intCount ; iCount ++ )
			{
				Point p2 = values[ iCount ] ;
				if( p2.X == x && p2.Y == y )
					return iCount ;
			}
			return -1 ;
		}
		
		/// <summary>
		/// боָݵĵ
		/// </summary>
		/// <param name="p">ָĵ</param>
		/// <returns>ҵĵбеĴ0ʼ,δҵ򷵻-1</returns>
		public int IndexOf( Point p )
		{
			return IndexOf( p.X , p.Y );
		}

		/// <summary>
		/// жбǷָݵĵ
		/// </summary>
		/// <param name="x">ָX</param>
		/// <param name="y">ָY</param>
		/// <returns>true:бָĵ false:</returns>
		public bool Contains( int x , int y )
		{
			return IndexOf( x , y ) >= 0 ;
		}
		
		/// <summary>
		/// жбǷָݵĵ
		/// </summary>
		/// <param name="p">ָ</param>
		/// <returns>true:бָĵ false:</returns>
		public bool Contains( Point p )
		{
			return IndexOf( p.X , p.Y ) >= 0 ;
		}

		/// <summary>
		/// ذݵĵ
		/// </summary>
		/// <returns></returns>
		public Point[] ToArray()
		{
			Point[] ps = new Point[ intCount ] ;
			Array.Copy( values , 0 , ps , 0 , intCount );
			return ps ;
		}

		/// <summary>
		/// б
		/// </summary>
		public void Clear()
		{
			intCount = 0 ;
			values = new Point[16];
			intVersion ++ ;
		}

		/// <summary>
		/// һ
		/// </summary>
		/// <param name="p"></param>
		public void Add( Point p )
		{
			CheckArray( intCount + 1 );
			values[ intCount ] = p ;
			intCount ++ ;
			intVersion ++ ;
		}

		/// <summary>
		/// ɾָŴԪض
		/// </summary>
		/// <param name="index"></param>
		public void RemoveAt( int index )
		{
			if( index < 0 || index >= intCount )
			{
				throw new IndexOutOfRangeException("index");
			}
			if( index == intCount - 1)
			{
				intCount -- ;
			}
			else
			{
				Array.Copy( values , index + 1 , values , index , intCount - index - 1 );
				intCount -- ;
			}
			intVersion ++ ;
		}

		/// <summary>
		/// еĵƶ
		/// </summary>
		/// <param name="dx">ƶ</param>
		/// <param name="dy">ƶ</param>
		public void Offset( int dx , int dy )
		{
			for( int iCount = 0 ; iCount < intCount ; iCount ++ )
			{
				values[ iCount ].Offset( dx , dy );
			}
		}
		#region ICollection Ա

		public bool IsSynchronized
		{
			get
			{
				// TODO:   PointArrayList.IsSynchronized getter ʵ
				return false;
			}
		}

		/// <summary>
		/// беĸ
		/// </summary>
		public int Count
		{
			get
			{
				return intCount ;
			}
		}

		public void CopyTo(Array array, int index)
		{
			Array.Copy( array , intCount , array , index , intCount );
		}

		public object SyncRoot
		{
			get
			{
				return null;
			}
		}

		#endregion

		#region IEnumerable Ա

		public IEnumerator GetEnumerator()
		{
			return new MyPointEnumerator( this );
		}

		#endregion

		private void CheckArray( int NewSize )
		{
			if( NewSize > values.Length )
			{
				Point[] ps = new Point[ ( int ) ( NewSize * 1.4 ) ] ;
				Array.Copy( values , 0 , ps , 0 , intCount );
				values = ps ;
			}
		}

		private System.Drawing.Point[] values = new Point[16];
		
		private int intCount = 0 ;
		 
		private int intVersion = 0 ;

		/// <summary>
		/// ڲĵö
		/// </summary>
		private class MyPointEnumerator : System.Collections.IEnumerator
		{
			private PointArrayList myList = null;
			private int version = 0 ;
			public MyPointEnumerator( PointArrayList list )
			{
				if( list == null )
					throw new System.ArgumentNullException("list");
				myList = list ;
				version = list.intVersion ;
			}
			private int intPosition = -1 ;

			#region IEnumerator Ա

			public void Reset()
			{
				intPosition = -1 ;
				version = myList.intVersion ;
			}

			public object Current
			{
				get
				{
					if( myList.intVersion != version )
						throw new System.Exception("бѸı");
					return myList.values[ intPosition ] ;
				}
			}

			public bool MoveNext()
			{
				if( myList.intVersion != version )
					throw new System.Exception("бѸı");
				intPosition ++ ;
				return ( intPosition < myList.intCount );
			}

			#endregion
		}//private class MyPointEnumerator : System.Collections.IEnumerator
	}//public class PointArrayList : System.Collections.ICollection
}